<?php
require_once SSC_APPLICATION_PATH . '/controllers/Abstract/Metabox.php';

class Ssc_Controller_MetaboxController
    extends Ssc_Controller_Abstract_Metabox
{
    public function indexAction()
    {
        $post = $this->_view->post = $this->getParam(0);
        $postId = $this->_view->postId = $post->ID;

        $form = $this->_view->form = Ssc_Application::getForm('Metabox')
            ->setPostId($postId)
            ->load();

        $meta = Ssc_Application::getModel('PostMeta')
            ->setPostId($postId);
        $this->_view->errors = (array) $meta->getValue('errors');
        $meta->unsetValue('errors');

        $this->_view->errors += $form->getErrors();

        $this->_view->seoScore = Ssc_Application::getService('SeoScore')
            ->setPostId($postId)
            ->load();
    }

    public function handleSavePostAction()
    {
        $this->setViewScript(NULL);

        $postId = $this->getParam(0);
        $post = $this->getParam(1);

        $form = $this->_view->form = Ssc_Application::getForm('Metabox')
            ->setPostId($postId)
            ->load();

        foreach ($form->getDataKeys() as $key) {
            if (isset($_POST['ssc_' . $key])) {
                $form->setValue($key, $_POST['ssc_' . $key]);
            }
        }

        $form->save();

        if ($form->isValid()) {
            $data = $form->getValues();
            $data['post'] = $post;
            try {
                Ssc_Application::getService('SeoScore')
                    ->analyze($data)
                    ->save();
            } catch (Ssc_Service_Exception $e) {
                Ssc_Application::getModel('PostMeta')
                    ->setPostId($postId)
                    ->setValue('errors', array($e->getMessage()));
            }
        } else {
            if (isset($_POST['ssc_primary']) && '' != $_POST['ssc_primary']) {
                Ssc_Application::getModel('PostMeta')
                    ->setPostId($postId)
                    ->setValue('errors', $form->getErrors());
            }
        }
    }

    public function relatedTermsAction()
    {
        $response = array('error' => '');

        try {
            $keyword = isset($_POST['keyword'])? $_POST['keyword'] : NULL;

            if ('' == $keyword) {
                $response['error'] = 'Keyword not specified';
            }

            try {
                $response['result'] = Ssc_Application::getModel('RelatedTerms')->get($keyword);
            } catch (Ssc_Model_RelatedTerms_Exception $e) {
                $response['error'] = $e->getMessage();
            }
        } catch (Exception $e) {
            $response['error'] = "Unexpected error: '{$e->getMessage()}'. Please contact the plug-in support.";
        }

        exit(json_encode($response));
    }
}