<?php
class Ssc_Model_Options
{
    const PREFIX = Ssc_WpPlugin::PREFIX;
    protected $_defaults = array(
        'keyword_density_min' => 1.5,
        'keyword_density_max' => 3.0,
    );

    public function getValue($name)
    {
        return get_option(self::PREFIX . $name, $this->getDefault($name));
    }

    public function setValue($name, $value)
    {
        return update_option(self::PREFIX . $name, $value);
    }

    public function unsetValue($name)
    {
        return delete_option(self::PREFIX . $name);
    }

    public function getDefaults()
    {
        return $this->_defaults;
    }

    public function getDefault($name)
    {
        return isset($this->_defaults[$name])
            ? $this->_defaults[$name]
            : NULL;
    }
}