<?php
class Ssc_Model_PostMeta
{
    const PREFIX = Ssc_WpPlugin::PREFIX;
    protected $_defaults = array();

    protected $_postId;

    public function getValue($name)
    {
        $this->_checkPostId();

        $result = get_post_meta($this->_postId, self::PREFIX . $name, TRUE);
        if ('' == $result) {
            $result = $this->getDefault($name);
        }

        return $result;
    }

    public function setValue($name, $value)
    {
        $this->_checkPostId();

        return update_post_meta($this->_postId, self::PREFIX . $name, $value);
    }

    public function unsetValue($name)
    {
        $this->_checkPostId();

        return delete_post_meta($this->_postId, self::PREFIX . $name);
    }

    public function setPostId($value)
    {
        $this->_postId = $value;
        return $this;
    }

    public function getPostId()
    {
        return $this->_postId;
    }

    protected function _checkPostId()
    {
        if (!$this->_postId) {
            throw new Exception('Post ID not specified');
        }
    }

    public function getDefaults()
    {
        return $this->_defaults;
    }

    public function getDefault($name)
    {
        return isset($this->_defaults[$name])
            ? $this->_defaults[$name]
            : NULL;
    }
}

