<?php
abstract class Ssc_Service_SeoScore_Factor_Abstract_Base
{
    protected $_visible = TRUE;
    protected $_label;
    protected $_factorType;
    protected $_metaName;
    protected $_value;
    protected $_extraData = array();

    /**
    * Performs factor analysis
    *
    * @param Ssc_Service_SeoScore $service
    */
    public function analyze($service)
    {
        //Implementation
    }

    public function __construct()
    {
        $this->init();
    }

    public function init()
    {
        // Extensions
    }

    public function getLabel()
    {
        return $this->_label;
    }

    public function getFactorType()
    {
        return $this->_factorType;
    }

    public function getMetaName()
    {
        return $this->_metaName;
    }

    public function getValue()
    {
        return $this->_value;
    }

    public function setValue($value)
    {
        $this->_value = $value;

        return $this;
    }

    public function getExtraData($key = NULL)
    {
        if (!is_null($key)) {
            return isset($this->_extraData[$key])? $this->_extraData[$key] : NULL;
        }

        return $this->_extraData;
    }

    public function setExtraData(array $value)
    {
        $this->_extraData = $value;

        return $this;
    }

    public function getVisible()
    {
        return $this->_visible;
    }

    abstract public function getFormattedValue();
}