<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Factor/Abstract/Base.php';

abstract class Ssc_Service_SeoScore_Factor_Abstract_Numeric
    extends Ssc_Service_SeoScore_Factor_Abstract_Base
{
    protected $_factorType = 'numeric';
    protected $_unit = '%';

    public function getUnit()
    {
        return $this->_unit;
    }

    public function getFormattedValue()
    {
        $value = $this->getValue();
        return is_null($value)? 'N/A' : $this->format($value);
    }

    public function format($value)
    {
        return "{$this->formatValue($value)}{$this->getUnit()}";
    }

    public function formatValue($value)
    {
        return (string)$value;
    }
}
