<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Factor/Abstract/Bool.php';

class Ssc_Service_SeoScore_Factor_DescriptionLength
    extends Ssc_Service_SeoScore_Factor_Abstract_Bool
{
    protected $_maxLength = 160;

    public function init()
    {
        parent::init();

        $this->_label = "Description meta tag contains up to {$this->_maxLength} characters.";
    }

    public function analyze($service)
    {
        $text = $service->analyzeMetaDescription('text');
        if (is_null($text)) {
            // Description not found
            $this->setValue(FALSE);
            return;
        }

        $length = $service->getHelper('Strings')->length($text);

        return $this->setValue($length <= $this->_maxLength);
    }

    public function getMaxLength()
    {
        return $this->_maxLength;
    }
}