<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Factor/Abstract/Numeric.php';

class Ssc_Service_SeoScore_Factor_Score
    extends Ssc_Service_SeoScore_Factor_Abstract_Numeric
{
    protected $_label = 'SEO Score';
    protected $_metaName = 'score';

    public function analyze($service)
    {
        $sum = 0;
        $count = 0;

        foreach ($service->getFactors('bool') as $factor) {
            if (!$factor->getVisible()) {
                continue;
            }

            $value = $factor->getValue();
            if (is_null($value)) {
                continue;
            }

            if ($value) {
                $sum++;
            }
            $count++;
        }

        $ratio = $count > 0? $sum/$count : 0;

        $this->setValue($ratio * 100);
    }

    public function formatValue($value)
    {
        return (string) round($value);
    }
}
